;; Copyright 2009 Kevin Ryde

;; This file is part of xtide-el.
;;
;; xtide-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; xtide-el is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with xtide-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


0 fdsjk
A fdsj
B fdk
C f
D fdsjk
E fs


;; emacs21 must have sort.el loaded to define sort-fold-case before making a
;; let-bind of it, otherwise after the let it's unbound and subsequent sort
;; funcs fail
  (eval-and-compile (require 'sort))


;; (xtide--with-case-table xtide-unaccent-case-table
;;   (compare-strings "a" nil nil "" nil nil))


    '(set-char-table-parent table (current-case-table))

    (let* ((table  (copy-sequence (current-case-table)))
           (from   "")
           (to     "aaaaaaaceeeeiiiinoooooouuuuyaaaaaaaceeeeiiiinoooooouuuuyy")
           (uptable (char-table-extra-slot table 0)))
      (set-char-table-extra-slot table 0 uptable)
      (dotimes (i (length from))
        (aset table (aref from i) (aref to i)))
      (setq to (upcase to))
      (dotimes (i (length from))
        (aset uptable (aref from i) (aref to i)))
      (setq xtide-unaccent-case-table table)))

;; xemacs
  (if (fboundp 'put-case-table)
      (let ((table (copy-case-table (current-case-table)))
            (from  "")
            (to    "aaaaaaaceeeeiiiinoooooouuuuyaaaaaaaceeeeiiiinoooooouuuuyy"))
        (dotimes (i (length from))
          (put-case-table 'downcase (aref from i) (aref to i) table))
        (setq xtide-unaccent-case-table table))

    


(with-case-table xtide-unaccent-case-table
  (describe-buffer-case-table))

(save-restriction
  (goto-char (point-min))
  (narrow-to-region (point) (save-excursion
                              (forward-line 6)
                              (point)))
  (sort-subr nil 'forward-line 'end-of-line))

(save-restriction
  (goto-char (point-min))
  (narrow-to-region (point) (save-excursion
                              (forward-line 6)
                              (point)))
  (set-char-table-parent xtide-unaccent-case-table (current-case-table))
  (with-case-table xtide-unaccent-case-table
    (let ((sort-fold-case t))
      (sort-subr nil 'forward-line 'end-of-line))))


  (eval-when-compile
    (concat "["
            (decode-coding-string
             (string ?192 ?193 ?194 ?195 ?196 ?197 ?198 ?199 ?200 ?201 ?202
                     ?203 ?204 ?205 ?206 ?207 ?209 ?210 ?211 ?212 ?213 ?214
                     ?216 ?217 ?218 ?219 ?220 ?221 ?224 ?225 ?226 ?227 ?228
                     ?229 ?230 ?231 ?232 ?233 ?234 ?235 ?236 ?237 ?238 ?239
                     ?241 ?242 ?243 ?244 ?245 ?246 ?248 ?249 ?250 ?251 ?252
                     ?253 ?255)
             'iso-8859-1)
            "]")))

(defun xtide-unaccent-string (str)
  (string-match xtide-unaccent-re


0F6C Aa
0F85 Bb
0F9D Cc
0FAE Dd
0FC7 Ee
0FF9 Ff
1003 Gg
1026 Hh
103C Ii
1054 Jj
1069 Kk
1077 Ll
10A1 Mm
10AC Nn
10CC Oo
10EE Pp
10FE Qq
110A Rr
1137 Ss
1157 Tt
1179 Uu
11A1 Vv
11AF Ww
11B8 Xx
11BD Yy

;;       (a
;;       (cadr elem)
;;     (aset table ?A ?b)
;;     (aset table ?B ?c)
;;     (aset table ?C ?d)
;;     (aset table ?D ?e)
;;     (aset table ?E ?a)

;;     (aset uptable ?e ?A)
;;     (aset uptable ?d ?B)
;;     (aset uptable ?c ?C)
;;     (aset uptable ?b ?D)
;;     (aset uptable ?a ?E)
;; 
;;     (set-char-table-extra-slot table 0 uptable)
